/* alocacao.c - Controle de alcacao e desalocacao de memorioa */

#include "estrdado.h"
#include "tela.h"
#include <alloc.h>

nivel_arvore aloca_nivel (void)
{

  nivel_arvore aux;

  if ((aux = farmalloc (sizeof (struct nivel_arvore))) == NULL) {
    mensagem ("Falta memoria para alocacao, abandonar.", ESP_ENTER);
    finaliza ();
  }
  aux->frase = NULL;
  aux->proximo = NULL;

  return aux;
}


categ_sintatica aloca_categ_sintatica (void)
{

  categ_sintatica aux;

  if ((aux = farmalloc (sizeof (struct categ_sintatica))) == NULL) {
    mensagem ("Falta memoria para alocacao, abandonar.", ESP_ENTER);
    finaliza ();
  }
  aux->tipo = aux->codigo_prim = aux->codigo_seg = 0;
  aux->prim_categ = aux->seg_categ = aux->proximo = NULL;

  return aux;
}


/* mostra lista */

void desaloca_lista (nivel_arvore inicio)
{
  nivel_arvore nodo_atual;
  categ_sintatica categ;

  for (nodo_atual = inicio; nodo_atual != NULL; )
  {
    nivel_arvore aux_nivel = nodo_atual;

    for (categ = nodo_atual->frase; categ != NULL; )
    {
      categ_sintatica aux_categ = categ;

      categ = categ->proximo;
      farfree (aux_categ);

    }

    nodo_atual = nodo_atual->proximo;
    farfree (aux_nivel);
  }
}



void desaloca_grupo_sen (nivel_arvore sentencas)
{

  nivel_arvore aux;

  for (aux = sentencas; aux != NULL; aux = sentencas)
  {
    sentencas = sentencas->proximo;
    farfree (aux);
  }
}
