/* estrdado.h */

/* Estruturas de informao */

typedef unsigned char byte;

/* categorias sintticas */

typedef enum {SEN = 1, ADJ, ADV, QU, SN, NC, PADV,
			  PNC, PSN, VC, VI, VT} tipo_classe;

typedef struct nivel_arvore {

  struct categ_sintatica huge *frase;  /* Ponteiro para a fila de catego-
                                          rias sintticas. */
  struct nivel_arvore huge *proximo;   /* Ponteiro para a implementao
                                          de uma fila de nveis da
                                          rvore */
} huge *nivel_arvore;


typedef struct categ_sintatica {

  tipo_classe tipo;            /* Indica qual das categorias sin-
                                 tticas este n representa. */
  byte codigo_prim,           /* Numero indicando as classes sintaticas
                                 formadoras da primeira categoria. */
       codigo_seg;            /* Idem para segunda. */

  struct categ_sintatica huge *prim_categ, /* Caso este n tenha sido gerado pela
					      juno de dois outros ns, este
					      ponteiro indicar qual o n que
					      entrou como o primeiro membro
					      da regra sinttica. */
			 huge *seg_categ,  /* Este ponteiro indica qual o n
					      que entrou como o segundo
					      membro da regra sinttica. */
			 huge *proximo;    /* Ponteiro para a implementao
					      da fila de categorias. */
} huge *categ_sintatica;

typedef struct regras_sintaticas {

  byte prim_oper,      /* Primeiro operando da regra sinttica. */
       seg_oper,       /* Segundo operando da regra sinttica. */
       result;         /* Resultado da regra sinttica. */

} regras_sintaticas;

